/*
	PIP - Platform Independent Primitives
	Digest algorithms
	Ivan Pelipenko peri4ko@yandex.ru

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "pidigest_blake2_p.h"

#include "3rd/BLAKE2/blake2.h"

#define IMPLEMENT(func, key_len)                                                                                                 \
	PIByteArray BLAKE2::func(const PIByteArray & in, const PIByteArray & key, int out_bytes) {                                   \
		PIByteArray ret(out_bytes);                                                                                              \
		::func(ret.data(), ret.size(), in.data(), in.size(), key.isEmpty() ? nullptr : key.data(), piMini(key.size(), key_len)); \
		return ret;                                                                                                              \
	}

IMPLEMENT(blake2s, BLAKE2S_KEYBYTES)
IMPLEMENT(blake2b, BLAKE2B_KEYBYTES)
IMPLEMENT(blake2sp, BLAKE2S_KEYBYTES)
IMPLEMENT(blake2bp, BLAKE2B_KEYBYTES)
IMPLEMENT(blake2xs, BLAKE2S_KEYBYTES)
IMPLEMENT(blake2xb, BLAKE2B_KEYBYTES)

#undef IMPLEMENT
